config/routes.rb
Rails.application.routes.draw do
  root "locations#index"

  resources :locations do
    resources :devices
  end
  resources :device_models
  resources :data_points, only: [:index, :create, :show] do
    resources :visualisations, only: :show
    resources :data_points_device, only: :show
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/data_point.rb
class DataPoint < ApplicationRecord
end

app/models/data_point_definition.rb
class DataPointDefinition < ApplicationRecord
  has_many :device_model_data_point_definitions
  has_many :device_models, through: :device_model_data_point_definitions
end

app/models/device.rb
class Device < ApplicationRecord
  belongs_to :location
  belongs_to :device_model
end

app/models/device_model.rb
class DeviceModel < ApplicationRecord
  has_many :devices
  has_many :device_model_data_point_definitions
  has_many :data_point_definitions, through: :device_model_data_point_definitions
end

app/models/device_model_data_point_definition.rb
class DeviceModelDataPointDefinition < ApplicationRecord
  belongs_to :device_model
  belongs_to :data_point_definition
end

app/models/location.rb
class Location < ApplicationRecord
  has_many :devices, dependent: :destroy #delete child records
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/data_points_controller.rb
class DataPointsController < ApplicationController
  protect_from_forgery with: :null_session

  def index
    render json: DataPoint.all
  end

  def show
    # fetch all entries via the device id
    data_point = DataPoint.where(device_id: params[:id])
    if data_point.nil?
      render json: data_point, status: :not_found
    else
      render json: data_point, status: :ok
    end
  end

  def create
    # validation logic should be put in extra method but did not figure out how to exit in there
    begin
      dev = Device.find(data_point_params[:device_id])
      definition = DataPointDefinition.find(data_point_params[:definition_id])
    rescue ActiveRecord::RecordNotFound
      # log error message here
    end
    if dev.nil? || definition.nil?
      # error handling could be more explicit
      render json: data_point_params, status: :unprocessable_entity
    else
      data_point = DataPoint.new(data_point_params)
      if data_point.save
        render json: data_point, status: :created
      else
        render json: data_point.errors, status: :unprocessable_entity
      end
    end
  end

  private
  def data_point_params
    params.require(:data_point).permit(:device_id, :definition_id, :value)
  end
end

app/controllers/data_points_device_controller.rb
class DataPointsDeviceController < ApplicationController
  def show
    # fetch all entries via the device id
    data_point = DataPoint.where(definition_id: params[:id], device_id: params[:data_point_id])
    if data_point.nil?
      render json: data_point, status: :not_found
    else
      render json: data_point, status: :ok
    end
  end

end

app/controllers/device_models_controller.rb
# frozen_string_literal: true
class DeviceModelsController < ApplicationController
  def index
    @device_models = DeviceModel.all
    @data_point_definitions = DataPointDefinition.all
  end

  def load_data
    @device_model = DeviceModel.find(params[:id])
    @definitions = []
    @device_model.device_model_data_point_definitions.each do |dev_model_data_point_def|
      # find per data point is not the best idea, also the .name at the end
      @definitions.push(DataPointDefinition.find(dev_model_data_point_def.data_point_definition.id).name)
    end
  end

  def show
    load_data
  end

  def new
    @device_model = DeviceModel.new
    @data_point_definitions = DataPointDefinition.all
    @device_model_data_point_definition = @device_model.device_model_data_point_definitions.build
  end

  def create
    @device_model = DeviceModel.new(device_model_params)

    #do the cross table referencing of device models and data point definition
    params[:data_point_definition][:id].each do |data_point|
      unless data_point.empty?
        @device_model.device_model_data_point_definitions.build(data_point_definition_id: data_point)
      end
    end

    if @device_model.save
      #makes new request to device_model
      redirect_to @device_model
    else
      render :new
    end
  end

  def edit
    @data_point_definitions = DataPointDefinition.all
    load_data
  end

  def update
    @device_model = DeviceModel.find(params[:id])

    if @device_model.update(device_model_params)
      redirect_to @device_model
    else
      render :edit
    end
  end

  def destroy
    @device_model = DeviceModel.find(params[:id])
    @device_model.destroy

    redirect_to root_path
  end

  private
  def device_model_params
    params.require(:device_model).permit(:name, :description)
  end
end

app/controllers/devices_controller.rb
class DevicesController < ApplicationController
  def show
    #:location_id is 1/1 for the first 1/2 for the second
    # there is probably a smarter way to do it
    device_url_part = params[:location_id].split("/")[1]
    @device = Device.find(device_url_part)

    # I assume this business logic needs to be placed somewhere else
    @latest_data_points_hash = Hash.new
    @device.device_model.device_model_data_point_definitions.each do |definition|
      data_def_id = definition.data_point_definition.id
      latest = DataPoint.where("device_id = :dev_id and definition_id = :def_id", {dev_id: @device.id, def_id: data_def_id}).last
      unless latest.nil?
        dataPointName = DataPointDefinition.find(data_def_id).name
        @latest_data_points_hash[dataPointName] = latest
      end
    end
  end

  def create
    @location = Location.find(params[:location_id])
    @device = @location.devices.create(device_params)
    redirect_to location_path(@location)
  end

  def destroy
    @location = Location.find(params[:location_id])
    @device = @location.devices.find(params[:id])
    @device.destroy
    redirect_to location_path(@location)
  end

  private
  def device_params
    params.require(:device).permit(:name, :description, :device_model_id)
  end
end

app/controllers/locations_controller.rb
class LocationsController < ApplicationController
  def index
    @locations = Location.all
  end

  def show
    @location = Location.find(params[:id])
  end

  def new
    @location = Location.new
  end

  def create
    @location = Location.new(location_params)

    if @location.save
      #makes new request to location
      redirect_to @location
    else
      render :new
    end
  end

  def edit
    @location = Location.find(params[:id])
  end

  def update
    @location = Location.find(params[:id])

    if @location.update(location_params)
      redirect_to @location
    else
      render :edit
    end
  end

  def destroy
    @location = Location.find(params[:id])
    @location.destroy

    redirect_to root_path
  end

  private
    def location_params
      params.require(:location).permit(:name, :address)
    end
end

app/controllers/visualisations_controller.rb
class VisualisationsController < ApplicationController
  def show
    device_id = params[:id]
    data_point_definition_id = params[:data_point_id]

    # fixme: I realized at a late point that this should call the internal API instead
    @data_points = DataPoint.where("device_id = :dev_id and definition_id = :def_id", {dev_id: device_id, def_id: data_point_definition_id})
    @data_point_name = DataPointDefinition.find(data_point_definition_id).name
    print @data_points
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/data_points_helper.rb
module DataPointsHelper
end

app/helpers/device_models_helper.rb
module DeviceModelsHelper
end

app/helpers/devices_helper.rb
module DevicesHelper
end

app/helpers/locations_helper.rb
module LocationsHelper
end

app/helpers/visualisations_helper.rb
module VisualisationsHelper
end

app/views/device_models/_form.html.erb
<%= form_with model: device_model do |form| %>
  <div class="form-group">
    <%= form.label :name %><br>
    <%= form.text_field :name , class: 'form-control'%>
  <br/>
    <%= form.label :description %><br>
    <%= form.text_area :description , class: 'form-control'%><br>
    <%= fields_for(@device_model_data_point_definition) do |pointDefinitions| %>
      <%= pointDefinitions.label "Name" %>
      <div class="field">
        <%= collection_select(:data_point_definition, :id, @data_point_definitions, :id, :name, {},{:multiple => true})  %>
      </div>
    <% end %>
    <br/>
    <%= form.submit 'Update Device Model', class: 'btn btn-success'%>
  </div>
<% end %>

app/views/device_models/edit.html.erb
<div class="container">
  <div class="page-header">
    <h1>Edit Device Models</h1>
    <h5><span class="label label-danger">Complete the information to update the device models</span></h5>
  </div>
</div>
<div class="container">
  <%= render "form", device_model: @device_model %>
  <%= link_to 'Back', root_path, class: 'label label-primary' %>
</div>

app/views/device_models/index.html.erb
<nav class="navbar navbar-light" style="background-color: #e3f2fd;">
  <div class="container">
    <ul class="nav">
      <li class="nav-item">
        <a class="nav-link" href="/locations/">Locations</a>
      </li>
      <li class="nav-item">
        <a class="nav-link" href="#">Device Models</a>
      </li>
      <li class="nav-item">
        <a class="nav-link" href="/data_points/">Data Points</a>
      </li>
    </ul>
  </div>
</nav>
<br/>

<div class="container">
  <div class="page-header">
    <h3>Device Models</h3>
  </div>
  <table class="table table-striped">
    <thead>
    <tr>
      <th class="text-center">Name</th>
      <th class="text-center">Description</th>
      <th class="text-center">Actions</th>
    </tr>
    </thead>
    <% @device_models.each do |device_model| %>
      <tr>
        <td><%= device_model.name %></td>
        <td><%= device_model.description %></td>
        <td class="text-center">
          <%= link_to "Show", device_model_path(device_model), class: 'label label-info'%>
          <%= link_to "Edit", edit_device_model_path(device_model), class: 'label label-success'%>
          <%= link_to "Delete", device_model, method: :delete, data: { confirm: "Are you sure?" }, class: 'label label-danger' %>
        </td>
      </tr>
    <% end %>
  </table>
  <div class="container">
    <%= link_to "New Device Model", new_device_model_path %>
  </div>
</div>
<br/>
<div class="container">
  <h4>Available data point definitions</h4>
  <ul>
    <% @data_point_definitions.each do |data_point_def| %>
      <li>
        <%= data_point_def.name%> ( <%= data_point_def.unit%> ) <%= data_point_def.id%>
      </li>
    <% end %>
  </ul>
</div>

app/views/device_models/new.html.erb
<div class="container">
  <div class="page-header">
    <h3>New Device Model</h3>
  </div>
</div>

<div class="container">
  <%= render "form", device_model: @device_model %>
  <div class="container">
    <%= link_to 'Back', device_models_path, class: 'label label-primary' %>
  </div>
</div>

app/views/device_models/show.html.erb
<div class="container">
  <div class="page-header">
    <h1><%= @device_model.name %></h1>
  </div>
</div>
<div class="container">
  <table class="table table-striped">
    <thead>
    <tr>
      <th class="text-center">Description</th>
      <th class="text-center">Data Points</th>
      <th class="text-center">Actions</th>
    </tr>
    </thead>
      <tr>
        <td><%= @device_model.description %></td>
        <!-- does not look that pretty, leaving it for now -->
        <td><%= @definitions %></td>
        <td class="text-center">
          <%= link_to "Edit", edit_device_model_path(@device_model), class: 'label label-success'%>
          <%= link_to "Delete", @device_model, method: :delete, data: { confirm: "Are you sure?" }, class: 'label label-danger' %>
        </td>
      </tr>
  </table>
  <div class="container">
    <%= link_to 'Back', device_models_path, class: 'label label-primary' %>
  </div>
</div>

app/views/devices/_device.html.erb
<tr>
    <td><%= device.id %></td>
    <td><%= device.name %></td>
    <td><%= device.description %></td>

    <td class="text-center">
      <%= link_to "Show", location_device_path([device.location, device]), class: 'label label-info'%>
      <%= link_to "Delete", [device.location, device], method: :delete, data: { confirm: "Are you sure?" }, class: 'label label-danger' %>
    </td>
</tr>

app/views/devices/_form.html.erb
<%= form_with model: [ @location, @location.devices.build ] do |form| %>
  <div class="form-group">
    <%= form.label :name %><br>
    <%= form.text_field :name , class: 'form-control'%>
  <br/>
    <%= form.label :description %><br>
    <%= form.text_area :description , class: 'form-control'%>
  <br/>
    <%= form.label :device_model %><br>
    <%= form.collection_select :device_model_id, DeviceModel.all, :id, :name %>
    <br/>
  <br/>
    <%= form.submit 'Update Device', class: 'btn btn-success'%>
  </div>
<% end %>

app/views/devices/index.html.erb
<h1>Devices#index</h1>
<p>Find me in app/views/devices/index.html.erb</p>

app/views/devices/show.html.erb
<div class="container">
  <div class="page-header">
    <h1><%= @device.name %></h1>
  </div>
</div>
<div class="container">
  <table class="table table-striped">
    <thead>
    <tr>
      <th class="text-center">Description</th>
      <th class="text-center">Device Model</th>
    </tr>
    </thead>
      <tr>
        <td><%= @device.description %></td>
        <td><%= @device.device_model.name %></td>
      </tr>
  </table>
  <h4>Latest Datapoints</h4>
  <table class="table table-striped">
    <thead>
    <tr>
      <th class="text-center">Data Point Defintion Name</th>
      <th class="text-center">Latest Value</th>
      <th class="text-center">Date</th>
      <th class="text-center">Detailed Chart</th>
    </tr>
    </thead>
    <% @latest_data_points_hash.each_pair do |key,value| %>
      <tr>
        <td><%= key %></td>
        <td><%= value.value %></td>
        <td><%= value.created_at %></td>
        <td><%= link_to "Details", data_point_visualisation_path(value.definition_id), class: 'label label-success'%></td>
      </tr>
    <% end %>
  </table>

</div>
<div class="container">
  <%= link_to 'Back', location_path, class: 'label label-primary' %>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>MiniIot</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/locations/_form.html.erb
<%= form_with model: location do |form| %>
  <div class="form-group">
    <%= form.label :name %><br>
    <%= form.text_field :name , class: 'form-control'%>
    <br/>
    <%= form.label :address %><br>
    <%= form.text_area :address , class: 'form-control'%><br>
    <br/>
    <%= form.submit "Update Location", class: 'btn btn-success'%>
  </div>
<% end %>

app/views/locations/edit.html.erb
<div class="container">
  <div class="page-header">
    <h1>Edit Location</h1>
    <h5><span class="label label-danger">Complete the information to update the location </span></h5>
  </div>
</div>
<div class="container">
  <%= render "form", location: @location %>
  <%= link_to 'Back', root_path, class: 'label label-primary' %>
</div>

app/views/locations/index.html.erb
<nav class="navbar navbar-light" style="background-color: #e3f2fd;">
  <div class="container">
    <ul class="nav">
      <li class="nav-item">
        <a class="nav-link" aria-current="page" href="#">Locations</a>
      </li>
      <li class="nav-item">
        <a class="nav-link" href="/device_models/">Device Models</a>
      </li>
      <li class="nav-item">
        <a class="nav-link" href="/data_points/">Data Points</a>
      </li>
    </ul>
  </div>
</nav>
<br/>
<div class="container">
  <div class="page-header">
    <h3>Locations</h3>
  </div>
  <table class="table table-striped">
    <thead>
    <tr>
      <th class="text-center">Name</th>
      <th class="text-center">Address</th>
      <th class="text-center">Actions</th>
    </tr>
    </thead>
    <% @locations.each do |location| %>
      <tr>
        <td><%= location.name %></td>
        <td><%= location.address %></td>
        <td class="text-center">
          <%= link_to "Show", location_path(location), class: 'label label-info'%>
          <%= link_to "Edit", edit_location_path(location), class: 'label label-success'%>
          <%= link_to "Delete", location, method: :delete, data: { confirm: "Are you sure?" }, class: 'label label-danger' %>
        </td>
      </tr>
    <% end %>
  </table>
  <div class="container">
    <%= link_to "New Location", new_location_path %>
  </div>
</div>

app/views/locations/new.html.erb
<div class="container">
  <div class="page-header">
    <h3>New Location</h3>
  </div>
</div>

<div class="container">
  <%= render "form", location: @location %>
  <div class="container">
    <%= link_to 'Back', locations_path, class: 'label label-primary' %>
  </div>
</div>

app/views/locations/show.html.erb
<div class="container">
  <div class="page-header">
    <h3>Location Details</h3>
  </div>
</div>

<div class="container">
  <table class="table table-striped">
    <thead>
    <tr>
      <th class="text-center">Name</th>
      <th class="text-center">Address</th>
      <th class="text-center">Actions</th>
    </tr>
    </thead>
    <tr>
      <td><%= @location.name %></td>
      <td><%= @location.address %></td>
      <td class="text-center">
        <%= link_to "Edit", edit_location_path(@location), class: 'label label-success'%>
        <%= link_to "Delete", @location, method: :delete, data: { confirm: "Are you sure?" }, class: 'label label-danger' %>
      </td>
    </tr>
  </table>
</div>
<br/><br/>

<div class="container">
  <div class="container">
    <div class="page-header">
      <h5>Device Information</h5>
    </div>
  </div>
  <div class="container">
    <table class="table table-striped">
      <thead>
      <tr>
        <th class="text-center">Device-Id</th>
        <th class="text-center">Name</th>
        <th class="text-center">Description</th>
        <th class="text-center">Actions</th>
      </tr>
      </thead>
      <%= render @location.devices %>
    </table>
  </div>
  <br/><br/>
  <div class="container">
    <div class="page-header">
      <h5>Add a device</h5>
    </div>
  </div>
  <div class="container">
    <%= render 'devices/form', button_text: "New Location" %>
  </div>
  <div class="container">
    <%= link_to 'Back', locations_path, class: 'label label-primary' %>
  </div>
</div>

app/views/visualisations/show.html.erb
<div class="container">
  <div class="jumbotron">
    <h1><%= @data_point_name %></h1>
  </div>
</div>
<div class="container">

  <%= line_chart @data_points.map { |point|
      {name: @data_point_name, data: point.value}}
  %>

</div>
<div class="container">
  <%= link_to 'Back', device_model_path, class: 'label label-primary' %>
</div>